Index: sys/sys/mac_private.h
===================================================================
RCS file: mac_private.h
diff -N mac_private.h
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ mac_private.h	Fri Oct  5 10:11:56 2001
@@ -0,0 +1,103 @@
+/*-
+ * Copyright (c) 1999-2001 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Private label management functions for mandatory security policies.
+ */							
+#ifndef _SYS_MAC_PRIVATE_H
+#define _SYS_MAC_PRIVATE_H
+
+/* Biba Integrity Policy. */
+int	mac_biba_cr_cansee __P((const struct ucred *u1,
+	    const struct ucred *u2));
+int     mac_biba_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_biba_equal __P((const struct mac *labela,
+	    const struct mac *labelb));
+void    mac_biba_init_subject __P((struct ucred *cred));
+void    mac_biba_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_biba_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_biba_init_object __P((struct mac *label));
+void    mac_biba_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_biba_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_biba_print_label __P((const struct mac *label));
+int	mac_biba_p_candebug __P((const struct proc *p1,
+	    const struct proc *p2));
+int	mac_biba_p_cansched __P((const struct proc *p1,
+	    const struct proc *p2));
+int	mac_biba_p_cansignal __P((const struct proc *p1, const struct proc *p2,
+	    int signum));
+int	mac_biba_vaccess __P((enum vtype type, const struct mac *filelabel,
+	    mode_t acc_mode, struct ucred *cred));
+
+/* Multi-Level Security Policy. */
+int	mac_mls_cr_cansee __P((const struct ucred *u1,
+	    const struct ucred *u2));
+int     mac_mls_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_mls_equal __P((const struct mac *labela, const struct mac *labelb));
+void    mac_mls_init_subject __P((struct ucred *cred));
+void    mac_mls_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_mls_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_mls_init_object __P((struct mac *label));
+void    mac_mls_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_mls_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_mls_print_label __P((const struct mac *label));
+int	mac_mls_p_candebug __P((const struct proc *p1, const struct proc *p2));
+int	mac_mls_p_cansched __P((const struct proc *p1, const struct proc *p2));
+int	mac_mls_p_cansignal __P((const struct proc *p1, const struct proc *p2,
+	    int signum));
+int	mac_mls_vaccess __P((enum vtype type, const struct mac *filelabel,
+	    mode_t acc_mode, struct ucred *cred));
+
+/* Light-Weight Partition Security Policy. */
+int     mac_partition_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_partition_equal __P((const struct mac *labela,
+	    const struct mac *labelb));
+void    mac_partition_init_subject __P((struct ucred *cred));
+void    mac_partition_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_partition_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_partition_init_object __P((struct mac *label));
+void    mac_partition_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_partition_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_partition_print_label __P((const struct mac *label));
+
+#endif /* !_SYS_MAC_PRIVATE_H */
Index: sys/sys/mbuf.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mbuf.h,v
retrieving revision 1.85
diff -u -r1.85 mbuf.h
--- sys/sys/mbuf.h	2001/09/30 01:58:35	1.85
+++ sys/sys/mbuf.h	2001/10/01 16:33:20
@@ -85,6 +85,7 @@
 	int	csum_flags;		/* flags regarding checksum */
 	int	csum_data;		/* data field used by csum routines */
 	struct	mbuf *aux;		/* extra data buffer; ipsec/others */
+	struct	mac label;		/* label of data in packet */
 };
 
 /*
Index: sys/sys/mount.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mount.h,v
retrieving revision 1.113
diff -u -r1.113 mount.h
--- sys/sys/mount.h	2001/09/12 08:38:05	1.113
+++ sys/sys/mount.h	2001/09/13 22:02:59
@@ -43,6 +43,7 @@
  */
 #include <sys/lockmgr.h>
 
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/queue.h>
 #ifdef _KERNEL
Index: sys/sys/proc.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/proc.h,v
retrieving revision 1.186
diff -u -r1.186 proc.h
--- sys/sys/proc.h	2001/10/07 19:47:37	1.186
+++ sys/sys/proc.h	2001/10/08 02:05:54
@@ -53,6 +53,7 @@
 #ifndef _KERNEL
 #include <sys/time.h>			/* For structs itimerval, timeval. */
 #endif
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <machine/proc.h>		/* Machine-dependent proc substruct. */
 
Index: sys/sys/ucred.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/ucred.h,v
retrieving revision 1.26
diff -u -r1.26 ucred.h
--- sys/sys/ucred.h	2001/10/11 23:38:17	1.26
+++ sys/sys/ucred.h	2001/10/16 01:23:41
@@ -60,6 +60,7 @@
 	struct	uidinfo *cr_uidinfo;	/* per euid resource consumption */
 	struct	uidinfo *cr_ruidinfo;	/* per ruid resource consumption */
 	struct	prison *cr_prison;	/* jail(4) */
+	struct	mac cr_label;		/* mandatory access control label */
 #define	cr_endcopy cr_mtx
 	struct	mtx cr_mtx;		/* protect refcount */
 };
@@ -78,6 +79,9 @@
 	short	cr_ngroups;		/* number of groups */
 	gid_t	cr_groups[NGROUPS];	/* groups */
 	void	*_cr_unused1;		/* compatibility with old ucred */
+#if 0
+	struct	mac cr_label;		/* mandatory access control label */
+#endif
 };
 
 #ifdef _KERNEL
Index: sys/sys/user.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/user.h,v
retrieving revision 1.45
diff -u -r1.45 user.h
--- sys/sys/user.h	2001/10/11 08:15:16	1.45
+++ sys/sys/user.h	2001/10/11 14:40:25
@@ -43,6 +43,7 @@
 #include <sys/errno.h>
 #include <sys/time.h>
 #include <sys/resource.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/_lock.h>
Index: sys/sys/vnode.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/vnode.h,v
retrieving revision 1.158
diff -u -r1.158 vnode.h
--- sys/sys/vnode.h	2001/10/01 04:33:35	1.158
+++ sys/sys/vnode.h	2001/10/03 11:30:09
@@ -543,6 +543,7 @@
 struct proc;
 struct stat;
 struct nstat;
+struct mac;
 struct ucred;
 struct uio;
 struct vattr;
@@ -574,6 +575,8 @@
 int	vaccess_acl_posix1e __P((enum vtype type, uid_t file_uid,
 	    gid_t file_gid, struct acl *acl, mode_t acc_mode,
 	    struct ucred *cred, int *privused));
+int	vaccess_mac __P((enum vtype type, const struct mac *filelabel,
+	    mode_t acc_mode, struct ucred *cred));
 void	vattr_null __P((struct vattr *vap));
 int	vcount __P((struct vnode *vp));
 void	vdrop __P((struct vnode *));
Index: sys/ufs/ffs/ffs_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_vfsops.c,v
retrieving revision 1.161
diff -u -r1.161 ffs_vfsops.c
--- sys/ufs/ffs/ffs_vfsops.c	2001/10/02 14:34:22	1.161
+++ sys/ufs/ffs/ffs_vfsops.c	2001/10/02 18:23:28
@@ -34,6 +34,7 @@
  * $FreeBSD: src/sys/ufs/ffs/ffs_vfsops.c,v 1.161 2001/10/02 14:34:22 rwatson Exp $
  */
 
+#include "opt_mac.h"
 #include "opt_quota.h"
 #include "opt_ufs.h"
 
@@ -712,6 +713,18 @@
 		ump->um_quotas[i] = NULLVP;
 #ifdef UFS_EXTATTR
 	ufs_extattr_uepm_init(&ump->um_extattr);
+#endif
+#ifdef MAC
+	/*
+	 * The following sets a file system to use default object labels
+	 * for system objects.
+	 *	 mac_init_object(&ump->um_label);
+	 */
+	/* The following inherits a file system label from the credential
+	 * of the caller.  mac_inherit_object knows what to do if cred is
+	 * NOCRED.
+	 */
+	mac_create_object(cred, &ump->um_label);
 #endif
 	devvp->v_rdev->si_mountpoint = mp;
 	ffs_oldfscompat(fs);
Index: sys/ufs/ufs/ufs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_vnops.c,v
retrieving revision 1.180
diff -u -r1.180 ufs_vnops.c
--- sys/ufs/ufs/ufs_vnops.c	2001/10/08 00:37:54	1.180
+++ sys/ufs/ufs/ufs_vnops.c	2001/10/08 02:05:58
@@ -39,6 +39,7 @@
  * $FreeBSD: src/sys/ufs/ufs/ufs_vnops.c,v 1.180 2001/10/08 00:37:54 dillon Exp $
  */
 
+#include "opt_mac.h"
 #include "opt_quota.h"
 #include "opt_suiddir.h"
 #include "opt_ufs.h"
@@ -60,6 +61,8 @@
 #include <sys/event.h>
 #include <sys/conf.h>
 #include <sys/acl.h>
+#include <sys/extattr.h>
+#include <sys/mac.h>
 
 #include <machine/mutex.h>
 
@@ -88,6 +91,9 @@
 static int ufs_close __P((struct vop_close_args *));
 static int ufs_create __P((struct vop_create_args *));
 static int ufs_getattr __P((struct vop_getattr_args *));
+#ifdef MAC
+static int ufs_getlabel __P((struct vop_getlabel_args *));
+#endif
 static int ufs_link __P((struct vop_link_args *));
 static int ufs_makeinode __P((int mode, struct vnode *, struct vnode **, struct componentname *));
 static int ufs_missingop __P((struct vop_generic_args *ap));
@@ -101,6 +107,9 @@
 static int ufs_rename __P((struct vop_rename_args *));
 static int ufs_rmdir __P((struct vop_rmdir_args *));
 static int ufs_setattr __P((struct vop_setattr_args *));
+#ifdef MAC
+static int ufs_setlabel __P((struct vop_setlabel_args *));
+#endif
 static int ufs_strategy __P((struct vop_strategy_args *));
 static int ufs_symlink __P((struct vop_symlink_args *));
 static int ufs_whiteout __P((struct vop_whiteout_args *));
@@ -337,6 +346,9 @@
 {
 	struct vnode *vp = ap->a_vp;
 	struct inode *ip = VTOI(vp);
+#ifdef MAC
+	struct mac label;
+#endif
 	mode_t mode = ap->a_mode;
 	int error;
 #ifdef UFS_ACL
@@ -367,9 +379,27 @@
 	}
 
 	/* If immutable bit set, nobody gets to write it. */
+	/* XXX: This breaks chflags(), please fix.
+	if ((mode & (VWRITE | VADMIN)) &&
+	    (ip->i_flags & (IMMUTABLE | SF_SNAPSHOT)))
+		return (EPERM);
+	*/
 	if ((mode & VWRITE) && (ip->i_flags & (IMMUTABLE | SF_SNAPSHOT)))
 		return (EPERM);
 
+#ifdef MAC
+	error = VOP_GETLABEL(vp, &label, ap->a_cred, ap->a_td);
+	if (error) {
+		printf("ufs_access: couldn't get any label (%d)\n", error);
+		return (error);
+	}
+	error = vaccess_mac(vp->v_type, &label, ap->a_mode, ap->a_cred);
+	if (error) {
+		printf("mac_vaccess returned %d for %d (%s)\n", error,
+		    ap->a_td->td_proc->p_pid, ap->a_td->td_proc->p_comm);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	MALLOC(acl, struct acl *, sizeof(*acl), M_ACL, M_WAITOK);
 	len = sizeof(*acl);
@@ -741,6 +771,102 @@
 	return (0);
 }
 
+#ifdef MAC
+/*
+ * Retrieve the MAC label on a file.
+ */
+static int
+ufs_getlabel(ap)
+	struct vop_getlabel_args /* {
+		struct vnode *a_vp;
+		struct mac *a_label;
+		struct ucred *a_cred;
+		struct thread *a_td;
+	} */ *ap;
+{
+	struct ufsmount *ump;
+	int error, len;
+
+	len = sizeof(*ap->a_label);
+	bzero(ap->a_label, sizeof(*ap->a_label));
+	error = vn_extattr_get(ap->a_vp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAMESPACE, FREEBSD_MAC_EXTATTR_NAME, &len,
+	    (char *) ap->a_label, ap->a_td);
+	switch (error) {
+	case 0:
+		/*
+		 * Successfully retrieved the label from disk.
+		 * Check the length, fail closed.
+		 */
+		if (len != sizeof(*ap->a_label)) {
+			printf("Corrupted label\n");
+			error = EPERM;
+		}
+		break;
+	case ENOENT:    /* XXX: Should be ENOATTR not ENOENT. */
+	case EOPNOTSUPP:
+		/*
+		 * If no label is available, return the mount label
+		 * instead.
+		 */
+		ump = VFSTOUFS(ap->a_vp->v_mount);
+		*ap->a_label = ump->um_label;
+		error = 0;
+		break;
+	default:
+	}
+
+	return (error);
+}
+
+/*
+ * Set the MAC label on a file.
+ */
+static int
+ufs_setlabel(ap)
+	struct vop_setlabel_args /* {
+		struct vnode *a_vp;
+		struct mac *a_label;
+		struct ucred *a_cred;
+		struct thread *a_td;
+	} */ *ap;
+{
+	struct mac old_label;
+	int error;
+
+	/*
+	 * First access check: does the caller have the ability to
+	 * administer the file system object to be labeled/re-labeled.
+	 */
+	error = VOP_ACCESS(ap->a_vp, VADMIN, ap->a_cred, ap->a_td);
+	if (error)
+		return (error);
+
+	/*
+	 * Second check: is the label being assigned to the object
+	 * appropriate based on the label previously assigned, and
+	 * the label on the subject.  To do this, must retrieve the
+	 * old label.
+	 */
+	error = VOP_GETLABEL(ap->a_vp, &old_label, ap->a_cred, ap->a_td);
+	if (error)
+		return (error);
+
+	error = mac_can_setlabel_object(ap->a_cred, &old_label, ap->a_label);
+	if (error)
+		return (error);
+
+	error = vn_extattr_set(ap->a_vp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAMESPACE, FREEBSD_MAC_EXTATTR_NAME,
+	    sizeof(*ap->a_label), (char *) ap->a_label, ap->a_td);
+	if (error)
+		return (error);
+	
+	VN_KNOTE(ap->a_vp, NOTE_ATTRIB);
+	return (0);
+}
+#endif /* !MAC */
+
 int
 ufs_remove(ap)
 	struct vop_remove_args /* {
@@ -1358,6 +1484,10 @@
 	struct buf *bp;
 	struct dirtemplate dirtemplate, *dtp;
 	struct direct newdir;
+#ifdef MAC
+	struct ufsmount *ump;
+	struct mac label;
+#endif
 #ifdef UFS_ACL
 	struct acl *acl, *dacl;
 #endif
@@ -1511,6 +1641,31 @@
 	error = UFS_UPDATE(tvp, !(DOINGSOFTDEP(dvp) | DOINGASYNC(dvp)));
 	if (error)
 		goto bad;
+
+#ifdef MAC
+	mac_create_object(cnp->cn_cred, &label);
+	error = vn_extattr_set(tvp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAMESPACE, FREEBSD_MAC_EXTATTR_NAME,
+	    sizeof(label), (char *) &label, cnp->cn_thread);
+	switch (error) {
+	case 0:
+		break;
+	case ENOENT: /* XXX: Should be ENOATTR. */
+	case EOPNOTSUPP:
+		/* Authorize creation of a file with the device label. */
+		ump = VFSTOUFS(tvp->v_mount);
+		error = mac_can(cnp->cn_cred, &ump->um_label, MAC_CREATE, 0);
+		if (error == 0)
+			break;
+		printf("ufs_mkdir: cannot assign MAC or use default\n");
+		/* Falls through. */
+	default:
+		printf("ufs_mkdir failed (%d)\n", error);
+		UFS_VFREE(tvp, ip->i_number, dmode);
+		vput(tvp);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	if (acl != NULL) {
 		/*
@@ -2247,6 +2402,10 @@
 	register struct inode *ip, *pdir;
 	struct direct newdir;
 	struct vnode *tvp;
+#ifdef MAC
+	struct ufsmount *ump;
+	struct mac label;
+#endif
 #ifdef UFS_ACL
 	struct acl *acl;
 #endif
@@ -2383,6 +2542,35 @@
 	error = UFS_UPDATE(tvp, !(DOINGSOFTDEP(tvp) | DOINGASYNC(tvp)));
 	if (error)
 		goto bad;
+/*
+ * Set the MAC label for the newly created file.  Attempt to set it using
+ * the credential of the writer; if this is not allowed, check to see if
+ * the writer has the same label as the default file system label.  If neither
+ * succeeds, then fail closed.
+ */
+#ifdef MAC
+	mac_create_object(cnp->cn_cred, &label);
+	error = vn_extattr_set(tvp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAMESPACE, FREEBSD_MAC_EXTATTR_NAME,
+	    sizeof(label), (char *) &label, cnp->cn_thread);
+	switch (error) {
+	case 0:
+	break;
+	case ENOENT: /* XXX: should be ENOATTR. */
+	case EOPNOTSUPP:
+		/* Authorize creation of a file with the device label. */
+		ump = VFSTOUFS(tvp->v_mount);
+		error = mac_can(cnp->cn_cred, &ump->um_label, MAC_CREATE, 0);
+		if (error == 0)
+			break;
+		/* Falls through. */
+	default:
+		printf("ufs_makeinode failed (%d)\n", error);
+		UFS_VFREE(tvp, ip->i_number, mode);
+		vput(tvp);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	if (acl != NULL) {
 		/*
@@ -2558,6 +2746,9 @@
 	{ &vop_close_desc,		(vop_t *) ufs_close },
 	{ &vop_create_desc,		(vop_t *) ufs_create },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif MAC
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_link_desc,		(vop_t *) ufs_link },
@@ -2578,6 +2769,9 @@
 	{ &vop_rename_desc,		(vop_t *) ufs_rename },
 	{ &vop_rmdir_desc,		(vop_t *) ufs_rmdir },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_strategy_desc,		(vop_t *) ufs_strategy },
 	{ &vop_symlink_desc,		(vop_t *) ufs_symlink },
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
@@ -2599,6 +2793,9 @@
 	{ &vop_access_desc,		(vop_t *) ufs_access },
 	{ &vop_close_desc,		(vop_t *) ufsspec_close },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_lock_desc,		(vop_t *) vop_stdlock },
@@ -2606,6 +2803,9 @@
 	{ &vop_read_desc,		(vop_t *) ufsspec_read },
 	{ &vop_reclaim_desc,		(vop_t *) ufs_reclaim },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
 	{ &vop_write_desc,		(vop_t *) ufsspec_write },
 #ifdef UFS_ACL
@@ -2625,6 +2825,9 @@
 	{ &vop_access_desc,		(vop_t *) ufs_access },
 	{ &vop_close_desc,		(vop_t *) ufsfifo_close },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_kqfilter_desc,		(vop_t *) ufsfifo_kqfilter },
@@ -2633,6 +2836,9 @@
 	{ &vop_read_desc,		(vop_t *) ufsfifo_read },
 	{ &vop_reclaim_desc,		(vop_t *) ufs_reclaim },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
 	{ &vop_write_desc,		(vop_t *) ufsfifo_write },
 #ifdef UFS_ACL
Index: sys/ufs/ufs/ufsmount.h
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufsmount.h,v
retrieving revision 1.22
diff -u -r1.22 ufsmount.h
--- sys/ufs/ufs/ufsmount.h	2001/09/12 08:38:11	1.22
+++ sys/ufs/ufs/ufsmount.h	2001/09/13 22:03:06
@@ -77,6 +77,7 @@
 	struct	vnode *um_quotas[MAXQUOTAS];	/* pointer to quota files */
 	struct	ucred *um_cred[MAXQUOTAS];	/* quota file access cred */
 	struct	ufs_extattr_per_mount um_extattr;	/* extended attrs */
+	struct	mac um_label;			/* immutable mounter label */
 	u_long	um_nindir;			/* indirect ptrs per block */
 	u_long	um_bptrtodb;			/* indir ptr to disk block */
 	u_long	um_seqinc;			/* inc between seq blocks */
Index: usr.bin/login/login.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/login/login.c,v
retrieving revision 1.69
diff -u -r1.69 login.c
--- usr.bin/login/login.c	2001/09/15 17:09:39	1.69
+++ usr.bin/login/login.c	2001/09/19 03:14:23
@@ -394,7 +394,13 @@
 	lc = login_getpwclass(pwd);
 
 	quietlog = login_getcapbool(lc, "hushlogin", 0);
+#if 0
 	/*
+	 * XXX: The sete[ug]id code here is broken in the base system
+	 * because it doesn't do setgroups().  It's even more broken
+	 * with MAC.  This test needs to happen further down, below
+	 * the setusercontext call.
+	 *
 	 * Switching needed for NFS with root access disabled.
 	 *
 	 * XXX: This change fails to modify the additional groups for the
@@ -414,6 +420,7 @@
 	}
 	(void)seteuid(euid);
 	(void)setegid(egid);
+#endif
 	if (!quietlog)
 		quietlog = access(_PATH_HUSHLOGIN, F_OK) == 0;
 
@@ -630,6 +637,22 @@
                 syslog(LOG_ERR, "setusercontext() failed - exiting");
 		exit(1);
 	}
+
+#if 1
+	/*
+	 * XXX: The home directory check should really go here, after
+	 * credentials are appropriately configured.
+	 */
+	if (!*pwd->pw_dir || chdir(pwd->pw_dir) < 0) {
+		if (login_getcapbool(lc, "requirehome", 0))
+			refused("Home directory not available", "HOMEDIR", 1);
+		if (chdir("/") < 0)
+			refused("Cannot find root directory", "ROOTDIR", 1);
+		if (!quietlog || *pwd->pw_dir)
+			printf("No home directory.\nLogging in with home = \"/\".\n");
+		pwd->pw_dir = "/";
+	}
+#endif
 
 	(void)setenv("SHELL", pwd->pw_shell, 1);
 	(void)setenv("HOME", pwd->pw_dir, 1);
Index: usr.bin/netstat/inet6.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/inet6.c,v
retrieving revision 1.18
diff -u -r1.18 inet6.c
--- usr.bin/netstat/inet6.c	2001/09/07 12:00:49	1.18
+++ usr.bin/netstat/inet6.c	2001/09/23 22:27:15
@@ -45,6 +45,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/ioctl.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/protosw.h>
 #include <sys/sysctl.h>
Index: usr.bin/netstat/iso.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/iso.c,v
retrieving revision 1.9
diff -u -r1.9 iso.c
--- usr.bin/netstat/iso.c	2001/06/15 23:55:45	1.9
+++ usr.bin/netstat/iso.c	2001/09/23 22:51:28
@@ -66,6 +66,7 @@
  */
 
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/time.h>
 #include <sys/domain.h>
Index: usr.bin/netstat/mbuf.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/mbuf.c,v
retrieving revision 1.29
diff -u -r1.29 mbuf.c
--- usr.bin/netstat/mbuf.c	2001/09/30 01:58:37	1.29
+++ usr.bin/netstat/mbuf.c	2001/10/01 17:19:30
@@ -40,6 +40,7 @@
 #endif /* not lint */
 
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/protosw.h>
 #include <sys/socket.h>
Index: usr.bin/netstat/mroute.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/mroute.c,v
retrieving revision 1.18
diff -u -r1.18 mroute.c
--- usr.bin/netstat/mroute.c	2001/09/07 12:59:30	1.18
+++ usr.bin/netstat/mroute.c	2001/09/23 22:51:39
@@ -54,6 +54,7 @@
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 #include <sys/protosw.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/time.h>
 
Index: usr.bin/netstat/ns.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/ns.c,v
retrieving revision 1.5
diff -u -r1.5 ns.c
--- usr.bin/netstat/ns.c	2001/06/15 23:55:45	1.5
+++ usr.bin/netstat/ns.c	2001/09/23 22:51:47
@@ -42,6 +42,7 @@
 #include <sys/param.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/protosw.h>
 
Index: usr.bin/netstat/unix.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/unix.c,v
retrieving revision 1.16
diff -u -r1.16 unix.c
--- usr.bin/netstat/unix.c	2001/06/15 23:35:13	1.16
+++ usr.bin/netstat/unix.c	2001/09/23 22:51:57
@@ -47,6 +47,7 @@
 #include <sys/protosw.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/sysctl.h>
 #include <sys/un.h>
Index: usr.bin/passwd/Makefile
===================================================================
RCS file: /home/ncvs/src/usr.bin/passwd/Makefile,v
retrieving revision 1.42
diff -u -r1.42 Makefile
--- usr.bin/passwd/Makefile	2001/09/13 06:48:17	1.42
+++ usr.bin/passwd/Makefile	2001/09/24 02:11:54
@@ -44,6 +44,9 @@
 	-I${.CURDIR}/../../usr.sbin/rpc.yppasswdd \
 	-Dyp_error=warnx -DLOGGING
 
+.if defined(MAC)
+CFLAGS+=-DMAC
+.endif
 .endif
 
 CLEANFILES= ${GENSRCS}
Index: usr.bin/passwd/local_passwd.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/passwd/local_passwd.c,v
retrieving revision 1.27
diff -u -r1.27 local_passwd.c
--- usr.bin/passwd/local_passwd.c	2001/03/11 16:37:30	1.27
+++ usr.bin/passwd/local_passwd.c	2001/05/31 14:50:00
@@ -39,6 +39,9 @@
 
 #include <sys/types.h>
 #include <sys/time.h>
+#ifdef MAC
+#include <sys/mac.h>
+#endif
 
 #include <ctype.h>
 #include <err.h>
@@ -70,6 +73,9 @@
 #include "extern.h"
 
 static uid_t uid;
+#ifdef MAC
+static mac_t label;
+#endif
 int randinit;
 
 char   *tempname;
@@ -208,6 +214,13 @@
 	uid = getuid();
 	if (uid && uid != pw->pw_uid)
 		errx(1, "%s", strerror(EACCES));
+#ifdef MAC
+	label = mac_get_proc();
+	if (label == NULL)
+		err(1, "mac_get_proc");
+	if (mac_set_proc(&mac_userland_system_high_label) == -1)
+		err(1, "mac_set_proc");
+#endif
 
 	pw_init();
 
Index: usr.bin/systat/mbufs.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/systat/mbufs.c,v
retrieving revision 1.15
diff -u -r1.15 mbufs.c
--- usr.bin/systat/mbufs.c	2001/09/30 01:58:39	1.15
+++ usr.bin/systat/mbufs.c	2001/10/01 17:19:42
@@ -39,6 +39,7 @@
 
 #include <sys/param.h>
 #include <sys/types.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/sysctl.h>
 
Index: usr.sbin/Makefile
===================================================================
RCS file: /home/ncvs/src/usr.sbin/Makefile,v
retrieving revision 1.209
diff -u -r1.209 Makefile
--- usr.sbin/Makefile	2001/09/11 01:13:15	1.209
+++ usr.sbin/Makefile	2001/09/19 02:44:58
@@ -34,6 +34,8 @@
 	fdread \
 	fdwrite \
 	getextattr \
+	getfmac \
+	getpmac \
 	gifconfig \
 	ifmcstat \
 	inetd \
@@ -100,7 +102,9 @@
 	rwhod \
 	sa \
 	setextattr \
+	setfmac \
 	setkey \
+	setpmac \
 	sliplogin \
 	slstat \
 	spray \
Index: usr.sbin/getfmac/Makefile
===================================================================
RCS file: Makefile
diff -N Makefile
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ Makefile	Sun Sep 23 22:12:26 2001
@@ -0,0 +1,5 @@
+PROG=   getfmac
+SRCS=   getfmac.c
+CFLAGS+=-Wall
+NOMAN=yes
+.include <bsd.prog.mk>
Index: usr.sbin/getfmac/getfmac.c
===================================================================
RCS file: getfmac.c
diff -N getfmac.c
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ getfmac.c	Sun Nov 19 17:56:36 2000
@@ -0,0 +1,34 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdio.h>
+
+int
+main(int argc, char *argv[])
+{
+	mac_t label;
+	char *string;
+	int i, had_error = 0;
+
+	if (argc < 2) {
+		fprintf(stderr, "getfmac [file ...]\n");
+		return (-1);
+	}
+
+	for (i = 1; i < argc; i++) {
+		label = mac_get_file(argv[i]);
+		if (label == NULL) {
+			perror(argv[i]);
+			had_error = -1;
+		} else {
+			string = mac_to_text(label, NULL);
+			if (string == NULL) {
+				perror(argv[i]);
+				had_error = -1;
+			} else
+				printf("%s: %s\n", argv[i], string);
+		}
+	}
+
+	return (had_error);
+}
Index: usr.sbin/getpmac/Makefile
===================================================================
RCS file: Makefile
diff -N Makefile
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ Makefile	Sun Sep 23 22:12:28 2001
@@ -0,0 +1,5 @@
+PROG=   getpmac
+SRCS=   getpmac.c
+CFLAGS+=-Wall
+NOMAN=yes
+.include <bsd.prog.mk>
Index: usr.sbin/getpmac/getpmac.c
===================================================================
RCS file: getpmac.c
diff -N getpmac.c
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ getpmac.c	Sun Nov 19 17:56:36 2000
@@ -0,0 +1,28 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdio.h>
+
+int
+main(int argc, char *argv[])
+{
+	struct mac label;
+	char *buf;
+	int error;
+
+	error = __mac_get_proc(&label);
+	if (error) {
+		perror("mac_get_proc");
+		return (-1);
+	}
+
+	buf = mac_to_text(&label, NULL);
+	if (buf == NULL) {
+		perror("mac_to_text");
+		return (-1);
+	}
+
+	printf("%s\n", buf);
+
+	return (0);
+}
Index: usr.sbin/i4b/ispppcontrol/ispppcontrol.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/i4b/ispppcontrol/ispppcontrol.c,v
retrieving revision 1.1
diff -u -r1.1 ispppcontrol.c
--- usr.sbin/i4b/ispppcontrol/ispppcontrol.c	2000/10/09 14:22:50	1.1
+++ usr.sbin/i4b/ispppcontrol/ispppcontrol.c	2001/09/24 15:27:58
@@ -42,7 +42,6 @@
 #include <sys/param.h>
 #include <sys/callout.h>
 #include <sys/ioctl.h>
-#include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/time.h>
 #include <sys/sysctl.h>
Index: usr.sbin/setfmac/Makefile
===================================================================
RCS file: Makefile
diff -N Makefile
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ Makefile	Sun Sep 23 22:12:46 2001
@@ -0,0 +1,5 @@
+PROG=   setfmac
+SRCS=   setfmac.c
+CFLAGS+=-Wall
+NOMAN=yes
+.include <bsd.prog.mk>
Index: usr.sbin/setfmac/setfmac.c
===================================================================
RCS file: setfmac.c
diff -N setfmac.c
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ setfmac.c	Sun Nov 19 17:56:36 2000
@@ -0,0 +1,30 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdio.h>
+
+int
+main(int argc, char *argv[])
+{
+	mac_t label;
+	int i, had_error = 0;
+
+	if (argc < 3) {
+		fprintf(stderr, "setfmac [label] [file ...]\n");
+		return (-1);
+	}
+
+	label = mac_from_text(argv[1]);
+	if (label == NULL) {
+		perror("mac_from_text");
+		return (-1);
+	}
+
+	for (i = 2; i < argc; i++)
+		if (mac_set_file(argv[i], label) != 0) {
+			perror(argv[i]);
+			had_error = -1;
+		}
+
+	return (had_error);
+}
Index: usr.sbin/setpmac/Makefile
===================================================================
RCS file: Makefile
diff -N Makefile
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ Makefile	Sun Sep 23 22:12:48 2001
@@ -0,0 +1,5 @@
+PROG=   setpmac
+SRCS=   setpmac.c
+CFLAGS+=-Wall
+NOMAN=yes
+.include <bsd.prog.mk>
Index: usr.sbin/setpmac/setpmac.c
===================================================================
RCS file: setpmac.c
diff -N setpmac.c
--- /dev/null	Tue Oct 16 15:55:02 2001
+++ setpmac.c	Sun Nov 19 17:56:36 2000
@@ -0,0 +1,41 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdio.h>
+#include <unistd.h>
+
+extern char *environ[];
+
+int
+main(int argc, char *argv[])
+{
+	struct mac *label;
+	int error;
+
+	if (argc < 3) {
+		fprintf(stderr, "setpmac [label] [binary] [args...]\n");
+		return (-1);
+	}
+
+	label = mac_from_text(argv[1]);
+	if (label == NULL) {
+		perror("mac_from_text");
+		return (-1);
+	}
+
+	error = __mac_set_proc(label);
+	if (error) {
+		perror("mac_set_proc");
+		return (-1);
+	}
+
+	mac_free(label);
+
+	error = execve(argv[2], argv + 2, environ);
+	if (error) {
+		perror(argv[2]);
+		return (-1);
+	}
+
+	return (0);
+}
